package org.greenstone.android.tipple.base;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Random;

import org.greenstone.android.tipple.R;

import android.app.Activity;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.drawable.Drawable;
import android.location.Location;
import android.speech.tts.TextToSpeech;

/**
 * Bad programming, but simplifies things.
 */
public class Global {

	private static Random randomGen;
	public static Activity activity;
	public static TextToSpeech tts;
	static HashMap<String, Bitmap> bitmapIcons;
	static HashMap<String, Drawable> drawableIcons;
	static ArrayList<TipLocation> locations;
	private static int numGenerated = 0; // the number of points created (for name generation) 

	static {
		randomGen = new Random();
		bitmapIcons = new HashMap<String, Bitmap>();
		drawableIcons = new HashMap<String, Drawable>();
	}

	public static int randomColor() {
		return randomGen.nextInt(1 << 24) + 0xff000000;
	}

	public static String randomIcon() {
		String[] icons = new String[] { "dinosaurpark", "house", "shop", "lecture" };
		int randomIndex = randomGen.nextInt(icons.length);
		return icons[randomIndex];
	}

	public static Bitmap getBitmap(String resourceName) {
		if (bitmapIcons.get(resourceName) == null) {
			int id = 0;
			if (resourceName != null) {
				id = activity.getResources().getIdentifier(resourceName, "drawable",
						activity.getPackageName());
			}
			if (id == 0) {
				id = R.drawable.marker;
			}
			Bitmap b = BitmapFactory.decodeResource(activity.getResources(), id);
			bitmapIcons.put(resourceName, b);
		}
		return bitmapIcons.get(resourceName);
	}

	public static Drawable getDrawable(String resourceName) {

		if (drawableIcons.get(resourceName) == null) {
			int id = 0;
			if (resourceName != null) {
				id = activity.getResources().getIdentifier(resourceName, "drawable",
						activity.getPackageName());
			}
			if (id == 0) {
				id = R.drawable.marker;
			}
			Drawable d = activity.getResources().getDrawable(id);
			d.setBounds(0 - d.getIntrinsicWidth() / 2, 0 - d.getIntrinsicHeight(),
					d.getIntrinsicWidth() / 2, 0);
			drawableIcons.put(resourceName, d);
		}
		return drawableIcons.get(resourceName);
	}

	public static TipLocation fixedLocation(Location current) {
		return makeTipLocation(-37.78804, 175.31238, 0);

	}

	public static TipLocation randomLocation(Location current) {
		double lat = current.getLatitude() + (randomGen.nextDouble() - 0.5) / 2000;
		double lon = current.getLongitude() + (randomGen.nextDouble() - 0.5) / 2000;
		double alt = current.getAltitude() + 4 * (randomGen.nextDouble() - 0.5)
				- LocationFusion.getInstance().lastKnownLocation.getAltitude();

		return makeTipLocation(lat, lon, alt);
	}

	public static TipLocation makeTipLocation(Location loc) {
		return makeTipLocation(loc.getLatitude(), loc.getLongitude(), loc.getAltitude()
				- LocationFusion.getInstance().lastKnownLocation.getAltitude());
	}

	public static TipLocation makeTipLocation(double lat, double lon, double alt) {
		HashMap<String, String> data = new HashMap<String, String>();

		data.put("latitude", Double.toString(lat));
		data.put("longitude", Double.toString(lon));
		data.put("altitude", Double.toString(alt));
		data.put("radius", "0.03");

		data.put("title", nextName());
		data.put("text", "This is a randomly generated location");
		data.put("tts", "This is a randomly generated location");
		data.put("tts_title", "Random Location " + data.get("title"));

		data.put("colour_fill", "#" + Integer.toHexString(randomColor()));
		data.put("colour_outline", "#" + Integer.toHexString(randomColor()));

		data.put("marker_type", randomIcon());

		data.put("audio", "");

		return new TipLocation(data);
	}
	
	private static String nextName()
	{
		numGenerated++;
		
		StringBuilder name = new StringBuilder();
		int i = numGenerated;
		while (i > 0)
		{
			name.insert(0, (char) ('A' + i % 26));
			i /= 26;
		}
		
		return name.toString();
	}
}
