package org.mapsforge.android.maps;

import org.greenstone.android.tipple.base.TippleActivity;

import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.DialogInterface.OnCancelListener;
import android.graphics.drawable.Drawable;
import android.speech.tts.TextToSpeech;

public class ArrayItemizedTextAudioOverlay extends ArrayItemizedOverlayTweaked
{
	protected final TextToSpeech tts_;
	protected AlertDialog dialogAlert;
	
	public ArrayItemizedTextAudioOverlay(Drawable defaultMarker, Context context, TextToSpeech tts)
	{
		super(defaultMarker,context);
		tts_ = tts;
	}

	@Override
	public synchronized boolean onTap(int index) {
		this.item = this.overlayItems.get(index);
		this.dialog = new AlertDialog.Builder(this.context);
		this.dialog.setTitle(this.item.getTitle());
		this.dialog.setMessage(this.item.getSnippet());
		
		this.dialog.setOnCancelListener(new OnCancelListener() {
			
			@Override
			public void onCancel(DialogInterface dialog) {
				tts_.stop();			
			}
		});
		
		dialogAlert = this.dialog.show();
			
		TippleActivity.log.optMessage("Manual Location Tap", "Title: " + item.getTitle());
		
		OverlayTextAudioItem ta_item = (OverlayTextAudioItem)this.overlayItems.get(index);
		tts_.speak(ta_item.getTTSTitle(), TextToSpeech.QUEUE_FLUSH, null);
		tts_.speak(ta_item.getTTSSnippet(), TextToSpeech.QUEUE_ADD, null);
	
		return true;
	}
	
	public synchronized boolean unTap() {
		
		dialogAlert.cancel();
		tts_.stop();
		return true;
	}
	
	/* public synchronized boolean onBackPressed() {
		
		dialogAlert.cancel();
		tts_.stop();	
		
		return true;
	} */
}

